import javax.swing.*;
import javax.swing.border.EtchedBorder;
import java.awt.*;

public class ChatRoomGUI extends JFrame {
    private final String WINDOWS_TITLE = "AUT Chat Room";
    private final int WIDTH = 500, HEIGHT = 500;
    private final int X = 100, Y = 100;
    private ChatArea chatBox = new ChatArea();
    private JPanel users = new JPanel();
    private ParticipantArea user = new ParticipantArea();
    private MessageArea messageArea = new MessageArea();
    private JPanel msgArea = new JPanel();
    public ChatRoomGUI(){
        super();
        this.setTitle(WINDOWS_TITLE);
        this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        this.setSize(WIDTH, HEIGHT);
        this.setLocation(X, Y);
        this.add(new JScrollPane().add(chatBox) ,BorderLayout.CENTER );
        chatBox.setBorder(BorderFactory.createEtchedBorder(EtchedBorder.RAISED));
        users.setLayout(new BorderLayout());
        users.setBorder(BorderFactory.createEtchedBorder(EtchedBorder.RAISED));
        users.add(user.getLabel() , BorderLayout.PAGE_START);
        users.add(user.getList() , BorderLayout.CENTER);
        this.add(users , BorderLayout.WEST);
        msgArea.setLayout(new BorderLayout());
        msgArea.add(new JScrollPane().add(messageArea) , BorderLayout.CENTER);
        msgArea.add(messageArea.getBtn() , BorderLayout.EAST);
        this.add(msgArea , BorderLayout.PAGE_END);
        users.setVisible(true);
        this.setVisible(true);
    }

    public MessageArea getMessageArea() {
        return messageArea;
    }

    public void addNewMessage(String name , String message){
        chatBox.addMessage(name , message);
    }
    public void addNewParticipant(String name){
        user.addUser(name);
    }
    public Boolean removeParticipant(String name){
        if(user.getListOfUsers().contains(name)){
            user.getListOfUsers().removeElement(name);
            return true;
        }
        else{
            return false;
        }
    }

}
